#### Beyond Linux® From Scratch (System V Edition) - Version 12.3

### Chapter 15. Networking Programs

- Prev

  rpcbind-1.2.7

- Next

  Samba-4.21.4

- Up
- Home

# rsync-3.4.1

## Introduction to rsync

The rsync package contains the rsync utility. This is useful for synchronizing large file archives over a network.

This package is known to build and work properly using an LFS 12.3 platform.

### Package Information

- Download (HTTP): https://www.samba.org/ftp/rsync/src/rsync-3.4.1.tar.gz

- Download MD5 sum: 04ce67866db04fd7a1cde0b78168406e

- Download size: 1.1 MB

- Estimated disk space required: 11 MB (with tests; add 24 MB for HTML API documentation)

- Estimated build time: 0.6 SBU (with tests)

### rsync Dependencies

#### Recommended

popt-1.19

#### Optional

Doxygen-1.13.2 and xxhash

## Installation of rsync

For security reasons, running the rsync server as an unprivileged user and group is encouraged. If you intend to run rsync as a daemon, create the `rsyncd` user and group with the following commands issued by the `root` user:

    groupadd -g 48 rsyncd &&
    useradd -c "rsyncd Daemon" -m -d /home/rsync -g rsyncd \
        -s /bin/false -u 48 rsyncd

Install rsync by running the following commands:

    ./configure --prefix=/usr    \
                --disable-xxhash \
                --without-included-zlib &&
    make

If you have Doxygen-1.13.2 installed and wish to build HTML API documentation, issue:

    doxygen

To test the results, issue: make check.

Now, as the `root` user:

    make install

If you built the documentation, install it using the following commands as the `root` user:

    install -v -m755 -d          /usr/share/doc/rsync-3.4.1/api &&
    install -v -m644 dox/html/*  /usr/share/doc/rsync-3.4.1/api

## Command Explanations

`--disable-xxhash`: This switch disables advanced xxhash checksum support. Remove this switch if you have installed xxhash.

`--without-included-zlib`: This switch enables compilation with the system-installed zlib library.

## Configuring rsync

### Config Files

`/etc/rsyncd.conf`

### Configuration Information

For client access to remote files, you may need to install the OpenSSH-9.9p2 package to connect to the remote server.

This is a simple download-only configuration to set up running rsync as a server. See the rsyncd.conf(5) man-page for additional options (i.e., user authentication).

    cat > /etc/rsyncd.conf << "EOF"
    # This is a basic rsync configuration file
    # It exports a single module without user authentication.

    motd file = /home/rsync/welcome.msg
    use chroot = yes

    [localhost]
        path = /home/rsync
        comment = Default rsync module
        read only = yes
        list = yes
        uid = rsyncd
        gid = rsyncd

    EOF

You can find additional configuration information and general documentation about rsync at https://rsync.samba.org/documentation.html.

### Boot Script

Note that you only need to start the rsync server if you want to provide an rsync archive on your local machine. You don't need this script to run the rsync client.

Install the `/etc/rc.d/init.d/rsyncd` init script included in the blfs-bootscripts-20250225 package.

    make install-rsyncd

## Contents

Installed Program: rsync and rsync-ssl
Installed Libraries: None
Installed Directories: Optionally, /usr/share/doc/rsync-3.4.1

### Short Descriptions

rsync | is a replacement for rcp (and scp) that has many more features. It uses the “rsync algorithm” which provides a very fast method of syncing remote files. It does this by sending just the differences in the files across the link, without requiring that both sets of files are present at one end of the link beforehand
rsync-ssl | is a helper script used when connecting to an rsync daemon that has SSL support built in

- Prev

  rpcbind-1.2.7

- Next

  Samba-4.21.4

- Up
- Home